function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var React = require('react');

var PropTypes = require('prop-types');

var _require = require('@cassette/core'),
    FullscreenContextProvider = _require.FullscreenContextProvider;

var MediaPlayerView = require('./components/MediaPlayerView');

var MediaPlayerUI =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(MediaPlayerUI, _React$PureComponent);

  function MediaPlayerUI() {
    return _React$PureComponent.apply(this, arguments) || this;
  }

  var _proto = MediaPlayerUI.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        getDisplayText = _this$props.getDisplayText,
        showVideo = _this$props.showVideo,
        fullscreenEnabled = _this$props.fullscreenEnabled,
        className = _this$props.className,
        style = _this$props.style;
    return React.createElement(FullscreenContextProvider, {
      fullscreenEnabled: fullscreenEnabled
    }, React.createElement(MediaPlayerView, {
      getDisplayText: getDisplayText,
      showVideo: showVideo,
      fullscreenEnabled: fullscreenEnabled,
      className: className,
      style: style
    }));
  };

  return MediaPlayerUI;
}(React.PureComponent);

MediaPlayerUI.propTypes = {
  getDisplayText: PropTypes.func.isRequired,
  showVideo: PropTypes.bool.isRequired,
  fullscreenEnabled: PropTypes.bool.isRequired,
  className: PropTypes.string,
  style: PropTypes.object
};
MediaPlayerUI.defaultProps = {
  getDisplayText: function getDisplayText(track) {
    if (!track) {
      return '';
    }

    return track.title || track.artist || track.album || '';
  },
  showVideo: false,
  fullscreenEnabled: false
};
module.exports = MediaPlayerUI;